# -*- coding: utf-8 -*-
"""
/***************************************************************************
 OpenShp
                                 A QGIS plugin
 This plugin opens shpfile
                              -------------------
        begin                : 2016-03-27
        git sha              : $Format:%H$
        copyright            : (C) 2016 by PKU
        email                : 315181538@qq.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt4.QtCore import QSettings, QTranslator, qVersion, QCoreApplication
from PyQt4.QtGui import QAction, QIcon,QFileDialog,QImage,QMessageBox,QGraphicsScene,QGraphicsView,QGraphicsPixmapItem,QPixmap
from PyQt4 import QtGui
from PyQt4 import QtCore, QtGui	
from qgis.core import *
from qgis.gui import *

# Initialize Qt resources from file resources.py
import resources
# Import the code for the dialog
from open_shp_dialog import OpenShpDialog
import os.path

##############
def draw():
        # create a memory layer with two points
        layer =  QgsVectorLayer('Point', 'points' , "memory")
        pr = layer.dataProvider() 
        # add the first point
        pt = QgsFeature()
        point1 = QgsPoint(50,50)
        pt.setGeometry(QgsGeometry.fromPoint(point1))
        pr.addFeatures([pt])
        # update extent of the layer
        layer.updateExtents()
        # add the second point
        pt = QgsFeature()
        point2 = QgsPoint(100,150)
        pt.setGeometry(QgsGeometry.fromPoint(point2))
        pr.addFeatures([pt])
        # update extent
        layer.updateExtents()
        # add the layer to the canvas
        QgsMapLayerRegistry.instance().addMapLayers([layer])
        return
def draw2(self):
    fileName = QFileDialog.getOpenFileName(self.dlg,"Open Image File")
    print(fileName)
    if fileName != '':   
       image = QImage(fileName)
       
       if image.isNull() is True:
          QMessageBox.information(self.dlg,"Image Viewer","Error Displaying image")
       else:          
            self.scene = QGraphicsScene()           
            self.dlg.graphicsView = QGraphicsView(self.scene)
            item = QGraphicsPixmapItem(QPixmap.fromImage(image))
            self.scene.addItem(item)
            self.scene.update()
            self.dlg.graphicsView.show()
    return
###########

class OpenShp:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'OpenShp_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Create the dialog (after translation) and keep reference
        self.dlg = OpenShpDialog()

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&OpenShp')
        # TODO: We are going to let the user set this up in a future iteration
        self.toolbar = self.iface.addToolBar(u'OpenShp')
        self.toolbar.setObjectName(u'OpenShp')
        self.dlg.pushButton.clicked.connect(self.select_output_file)

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('OpenShp', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            self.toolbar.addAction(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/OpenShp/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'OpenShp'),
            callback=self.run,
            parent=self.iface.mainWindow())


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&OpenShp'),
                action)
            self.iface.removeToolBarIcon(action)
        # remove the toolbar
        del self.toolbar

################add my draw function
    def convertLngLatToXY(lng, lat, w, h, minlng, maxlng, minlat, maxlat):
	x = w * (lng - minlng) / (maxlng - minlng)
	y = h * (maxlat - lat) / (maxlat - minlat)
	return (x, y)
  
       
    

    def select_output_file(self):
        filename = QFileDialog.getSaveFileName(self.dlg, "Select output file ","", '*.txt')
        #self.dlg.lineEdit.setText(filename) 
        return filename

########################
    def run(self):
        """Run method that performs all the real work"""
        ######
        layers = self.iface.legendInterface().layers()
        layer_list = []
        for layer in layers:
         layer_list.append(layer.name())
         self.dlg.comboBox.addItems(layer_list)

         
        ####
        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            
            # Do something useful here - delete the line containing pass and
            # substitute with your code.
            #filename = QFileDialog.getSaveFileName(self.dlg, "Select output file ","", '*.txt')
            ##filename = self.dlg.lineEdit.text()
            '''
            QMessageBox()
            filename = self.select_output_file
            output_file = open(filename, 'w')
           
            selectedLayerIndex = self.dlg.comboBox.currentIndex()
            selectedLayer = layers[selectedLayerIndex]
            fields = selectedLayer.pendingFields()
            fieldnames = [field.name() for field in fields]
            
            for f in selectedLayer.getFeatures():
                line = ','.join(unicode(f[x]) for x in fieldnames) + '\n'
                unicode_line = line.encode('utf-8')
                output_file.write(unicode_line)
            output_file.close()'''
            draw2(self)
           
            




